#include "testlib.h"
#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) (int)(s).size()
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

int main(int argc, char* argv[]) {
	//ios::sync_with_stdio(false); cin.tie(0);

	setName("checker");
	registerTestlibCmd(argc, argv);

    uint64_t pans = ouf.readUnsignedLong();
    uint64_t jans = ans.readUnsignedLong();
    if (pans != jans)
    	quitf(_wa, "jury (%lu) and participant's (%lu) answers differ", jans, pans);

    size_t n = inf.readInt();
    vector<size_t> deg(n);
    set<pair<size_t, size_t>> edges;
    for (size_t i = 0; i < n - 1; i++) {
    	size_t u = inf.readInt() - 1, v = inf.readInt() - 1;
    	deg[u]++; deg[v]++;
    	edges.insert({u, v});
    	edges.insert({v, u});
    }

    size_t ju = ans.readInt(1, n, "jury u") - 1, jv = ans.readInt(1, n, "jury v") - 1;
    uint64_t sum_deg = jans - deg[ju] - deg[jv];

    size_t pu = ouf.readInt(1, n, "participant u") - 1, pv = ouf.readInt(1, n, "participant v") - 1;
    if (pu == pv)
    	quitf(_wa, "loops are forbidden");
    if (edges.count({pu, pv}))
    	quitf(_wa, "multiple edges are forbidden");
    if (sum_deg + deg[pu] + deg[pv] != pans)
    	quitf(_wa, "printed (%lu) and actual (%lu) participant's number of claws differ", pans, sum_deg + deg[pu] + deg[pv]);

    quitf(_ok, "valid pair of verices");
}
