#include "testlib.h"
#include <stdio.h>
#include <bits/stdc++.h>
#define endl '\n'
#define ALL(c) begin(c), end(c)

using namespace std;
using ll = long long;

vector<pair<int,int>> tree_from_degs(vector<int> degs){
    int n = size(degs);
    assert(accumulate(ALL(degs),0LL) == (n-1)*2);
    
    vector<int> v1, v;
    for(int i=0;i<n;++i){
        assert(degs[i]>0);
        if(degs[i]==1) v1.push_back(i); 
        else v.push_back(i);
    }
    
    vector<pair<int,int>> edges;
    
    for(;;){
        assert(!empty(v1));
        
        int k,i,j;
        for(;;){
            if(empty(v)){
                assert(size(v1) == 2);
                edges.emplace_back(v1[0],v1[1]);
                return edges;
            }
            
            k = rnd.next(0,int(size(v))-1);
            j = v[k];
            if(degs[j]>1) break;
            v[k] = v.back();
            v.pop_back();
        }
        
		
        k = rnd.next(0,int(size(v1))-1);
        i = v1[k];
        v1[k] = v1.back();
        v1.pop_back();
        
        edges.emplace_back(i,j);
        
        degs[i]--;
        degs[j]--;
        if(degs[j]==1) v1.push_back(j);
    }
}

int gen_max_deg(int n, int cm){
    // m * cm + (n-cm) <= 2(n-1)
    int small = n-cm;
    int mr = ((n-1)*2-small) / cm;
    int ml = 0;
    for(;;){
        int d = (n-1)*2 - (ml*cm + small);
        int h = 1 + d/small + (d%small>0);
        if(h < ml) break;
        ++ml;
    }
    return rnd.next(ml,mr);
}


int main(int argc, char* argv[]){
    registerGen(argc, argv, 1);
    
    
    int it = 1;
    
    int n = atof(argv[it++]);
    string str = (argv[it++]);
    
    vector<pair<int,int>> edges;
    
    
    
    if(str=="rand"){
        int w = atoi(argv[it++]);
        for(int i=1;i<n;++i) edges.emplace_back(i,rnd.wnext(0,i-1,w));
    }else
    if(str=="line"){
        for(int i=1;i<n;++i) edges.emplace_back(i,i-1);
    }else
    if(str=="star"){
        for(int i=1;i<n;++i) edges.emplace_back(i,0);
    }else
    if(str=="bydegs"){
        vector<int> deg(n,1);
        int rem = n-2;
        str = (argv[it++]);
        if(str == "rand"){
            for(int k=0;k<rem;++k) ++deg[rnd.next(0,n-1)];
        }else
        if(str == "cntmax"){
            const int cm = atoi(argv[it++]);
            assert(1<=cm && cm<=n);
            
            int m = gen_max_deg(n,cm);
            for(int i=0;i<cm;++i) deg[i] = m, rem-=m-1;
            
            vector<int> pool;
            for(int i=0;i<n;++i) if(deg[i]<m) pool.push_back(i);
            while(rem>0){
                --rem;
                assert(!empty(pool));
                int k = rnd.next(0, int(size(pool))-1);
                int i = pool[k];
                ++deg[i];
                if(deg[i] == m-1){
                    pool[k] = pool.back();
                    pool.pop_back();
                }
            }
        }
        
        edges = tree_from_degs(deg);
    }else
    if(str == "spec_mx2a"){
        //2 maxs, not near
        while((n*2-2)%4 != 0) --n;
        
        int m = (n*2-2) / 4;
        for(int i=0;i<m-1;++i){
            edges.emplace_back(0, i+1);
            edges.emplace_back(m, i+1+m);
        }
        edges.emplace_back(n-1,1);
        edges.emplace_back(n-1,n-2);
    }else
    if(str == "spec_mx2b"){
        //2 maxs, near, second max near one of max
        while((n*2-2)%4 != 0) --n;
        
        int m = (n*2-2) / 4;
        for(int i=0;i<m;++i) edges.emplace_back(0, i+1);
        for(int i=0;i<m-1;++i) edges.emplace_back(m, m+i+1);
        edges.emplace_back(n-1, n-2);
    }else
    if(str == "spec_mx1a"){
        //1 max, ans is max + !near
        
    }else
    if(str == "spec_mx1b"){
        //1 max, ans is two nears of max
        while((n*2+6)%6 != 0) --n;
        
        int m = (n*2+6) / 6;
        int vn = 0;
        int mx = vn++;
        for(int i=0;i<m-2;++i) edges.emplace_back(mx, vn++);
        int t1 = vn++;
        int t2 = vn++;
        edges.emplace_back(mx, t1);
        edges.emplace_back(mx, t2);
        for(int i=0;i<m-2;++i){
            edges.emplace_back(t1, vn++);
            edges.emplace_back(t2, vn++);
        }
        assert(vn == n);
        
    }else
    if(str == "spec1"){
        while(n%2==0) --n;
        for(int i=1;i<=n/2;++i){
            edges.emplace_back(0,i);
            edges.emplace_back(i,i+n/2);
        }
    }
    
    
    
    
    vector<int> p(n);
    iota(ALL(p),0);
    shuffle(ALL(p));
    
    shuffle(ALL(edges));
    
    cout<<n<<endl;
    for(auto [i,j] : edges){
        i = p[i] + 1;
        j = p[j] + 1;
        cout<<i<<' '<<j<<endl;
    }
    
    
    return 0;
}



