#include "testlib.h"
#include <bits/stdc++.h>
#define ALL(c) (c).begin(), (c).end()
using ll = long long;
using namespace std;

struct dsu {
	vector<int> p, sz;
	dsu(int n): sz(n,1), p(n) {
		iota(ALL(p),0);
	}
	int get(int i){
		int v = i;
		while(v!=p[v]) v = p[v];
		while(i!=p[i]) i = exchange(p[i],v);
		return v;
	}
	bool unite(int i, int j){
		i = get(i);
		j = get(j);
		if(i==j) return false;
		if(sz[i]<sz[j]) swap(i,j);
		p[j] = i;
		sz[i]+=sz[j];
		return true;
	}
};

int main(int argc, char* argv[]){
    registerValidation(argc, argv);
	
	
	int n = inf.readInt(3, 2e5, "n");
	inf.readEoln();
	
	dsu q(n);
	for(int i=1;i<n;++i){
		int u = inf.readInt(1, n, "u_" + i) - 1;
		inf.readSpace();
		int v = inf.readInt(1, n, "v_" + i) - 1;
		
		if(!q.unite(v,u)){
			quitf(_fail, "loops and cycles (%d-th edge: %d %d) are forbidden", i + 1, u + 1, v + 1);
		}
		
		inf.readEoln();
	}
	
	inf.readEof();
	
    return 0;
}
