// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")

#include <bits/stdc++.h>
#define ALL(s) (s).begin(), (s).end()
#define rALL(s) (s).rbegin(), (s).rend()
#define sz(s) (s).size()
#define sqr(s) ((s) * (s))
#define pos(x) (2 * (x))
#define neg(x) (2 * (x) + 1)

using ll = long long;
using namespace std;

size_t n;
uint64_t ans;
pair<size_t, size_t> p_ans;
vector<size_t> g[200500];
set<pair<size_t, size_t>> s;

uint64_t deg(size_t v) {
	return g[v].size();
}

void insert_neighborhood(size_t v, size_t p) {
	for (size_t u : g[v]) {
		if (u == p)
			continue;
		s.insert({deg(u), u});
	}
}

void erase_neighborhood(size_t v) {
	for (size_t u : g[v]) {
		s.erase({deg(u), u});
	}
}

void dfs(size_t v, size_t p = 0) {
	erase_neighborhood(v);

	if (!s.empty()) {
		size_t w = s.rbegin()->second;
		if (deg(v) + deg(w) > ans) {
			ans = deg(v) + deg(w);
			p_ans = {v, w};
		}
	}

	for (size_t u : g[v]) {
		if (u == p)
			continue;
		insert_neighborhood(v, u);
		dfs(u, v);
		erase_neighborhood(v);
	}

	insert_neighborhood(v, p);
}

int main() {
	ios::sync_with_stdio(false); cin.tie(0);
	// cout.precision(9); cout << fixed;
#ifdef EUGENE
	freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
#else
	// freopen("nfc.in", "r", stdin);
	// freopen("nfc.out", "w", stdout);
#endif
	
	cin >> n;
	for (size_t i = 0; i < n - 1; i++) {
		size_t u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	for (size_t v = 2; v <= n; v++) {
		s.insert({deg(v), v});
	}

	dfs(1);

	for (size_t v = 1; v <= n; v++) {
		ans += deg(v) * (deg(v) - 1) / 2;
	}

	cout << ans << endl;
	cout << p_ans.first << " " << p_ans.second << endl;
}
